#import "GPSController.h"
#import "GPSDrawing.h"
#import "gps-alex1.h"
#define PI 3.1415926535898

@implementation GPSController

- (IBAction)setLocalDate:(id)sender
{
	[self setLocalDateInfo];
}

- (IBAction)liveUpdate:(id)sender
{
	if ([liveButton state]){
			[NSThread detachNewThreadSelector:@selector(updateclock:) toTarget:self withObject:nil];
	} else {
		[timeText setStringValue:[[NSDate date] descriptionWithCalendarFormat:@"%H:%M:%S" timeZone:nil locale:nil]];
	}
}

- (void)updateclock:(id)anObject
{
	// create new autorelease pool for the thread
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

	// animate
	while ([liveButton state]) {
		[NSThread sleepUntilDate:[NSDate dateWithTimeIntervalSinceNow:1]];
		[timeText setStringValue:[[NSDate date] descriptionWithCalendarFormat:@"%H:%M:%S" timeZone:nil locale:nil]];
	}

	// release the autorelease pool
	[pool release];
}

- (IBAction)calculsat:(id)sender
{	
	if (!almanacFlag){
		NSLog(@"Choose almanac first!");
	  NSRunAlertPanel(@"Erreur",@"Choisissez un almanac.", @"OK",NULL,NULL);
	} 
	else if ( !app_is_runningFlag ) {
		app_is_runningFlag = 1;
		[calcButton setTitle:@"Stoppe le calcul"];
	//	NSLog(@"Almanac: %s",[almanacFile cString]);
	  [NSThread detachNewThreadSelector:@selector(docalcul:) toTarget:self withObject:nil];
		if (![liveButton state]) {
			app_is_runningFlag = 0; // if not live update, we perform only one calculation and stop
			[calcButton setTitle:@"Lance le calcul"];
		}
	}
	else if ( app_is_runningFlag ) {
		app_is_runningFlag = 0;
		[calcButton setTitle:@"Lance le calcul"];
	}
}

- (void)docalcul:(id)anObject
{
		// create new autorelease pool for the thread
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

	int Hour=0,Minute=0,Secondes=0,Day,UTC_Zone=0,long_d=0,long_m=0,lat_d=0,lat_m=0,alt=0;
	int nb_sat,boucle;
	sat_to_draw_t my_sat[32]; // max 32 sat  - Sat ID, Azimuth, Elevation

	//NSCalendarDate *calcul_date = [NSCalendarDate calendarDate];

	// animate
	do {
		long_d = [lon_degText intValue];
		long_m = [lon_minText intValue];
		lat_d = [lat_degText intValue];
		lat_m = [lat_minText intValue];
		alt = [altitudeText floatValue];
		Day = [dayOfWeekPopUp indexOfSelectedItem];
		//Hour = [calcul_date hourOfDay]; // this is the LOCAL hour, not hat could be choosen by the user
		//Minute = [calcul_date minuteOfHour];
		UTC_Zone = [timezoneText intValue]; // this is in hours

		sscanf([[timeText stringValue] cString],"%d:%d:%d",&Hour,&Minute,&Secondes);
		//NSLog(@"D=%d H=%d M=%d Text=%s",Day, Hour, Minute,[[timeText stringValue] cString]);
		NSLog(@"%s",(char *)[almanacFile UTF8String]);
		//nb_sat = main_gps((char *)[almanacFile cString],Hour,Minute,UTC_Zone,Day,long_d,long_m,lat_d,lat_m,alt,my_sat);
		nb_sat = main_gps((char *)[almanacFile UTF8String],Hour,Minute,UTC_Zone,Day,long_d,long_m,lat_d,lat_m,alt,my_sat);
		for (boucle=0;boucle<nb_sat;boucle++){
			NSLog(@"Satellite %2d :  El=%6.2f  Az=%6.2f\n",my_sat[boucle].num,my_sat[boucle].elevation * 180.0/PI,my_sat[boucle].azimuth * 180.0/PI);
		}
		[gpsView testdraw:nb_sat visiblesat:my_sat];
		[NSThread sleepUntilDate:[NSDate dateWithTimeIntervalSinceNow:5]];
	}
	while (app_is_runningFlag && [liveButton state]);

	// release the autorelease pool
	[pool release];
}

- (IBAction)getLastAlmanacSync:(id)sender
{
	NSURL *myURL = [NSURL URLWithString:@"http://www.navcen.uscg.gov/ftp/GPS/almanacs/yuma/Yuma.txt"];
	NSData *urlContents = [myURL resourceDataUsingCache:YES];
	[asyncFeedback setIndeterminate:YES];
	[asyncFeedback startAnimation:(id)sender];
	if ([urlContents writeToFile:[@"~/Documents/almanac.txt" stringByExpandingTildeInPath] atomically:YES])
	{
		 // It was successful, do stuff here
		[asyncFeedback stopAnimation:(id)sender];
		[asyncFeedback setIndeterminate:NO];
	} else {
		 // There was a problem writing the file
		 NSRunAlertPanel(@"Error",@"Sorry, impossible d'obtenir le fichier.", @"OK",NULL,NULL);
		[asyncFeedback stopAnimation:(id)sender];
		[asyncFeedback setIndeterminate:NO];
	 }
}

- (IBAction)getLastAlmanacAsync:(id)sender
{
	NSURL *myURL = [NSURL URLWithString:@"http://www.navcen.uscg.gov/ftp/GPS/almanacs/yuma/Yuma.txt"];
	[asyncFeedback setIndeterminate:YES];
	[asyncFeedback startAnimation:(id)sender];
	[myURL loadResourceDataNotifyingClient:self usingCache:YES];
}

- (void)URLResourceDidFinishLoading:(NSURL *)sender
{
	NSData *urlContents = [sender resourceDataUsingCache:YES];
	if ([urlContents writeToFile:[@"~/Documents/almanac.txt" stringByExpandingTildeInPath] atomically:YES])
	{
		// It was successful, do stuff here
		[asyncFeedback stopAnimation:(id)sender];
		[asyncFeedback setIndeterminate:NO];
	} else {
		// There was a problem writing the file
		NSRunAlertPanel(@"Error",@"Sorry, impossible d'obtenir le fichier.", @"OK",NULL,NULL);
	}
}

- (IBAction)gotoSite:(id)sender
{
	NSString *emailAddress = @"www.navcen.uscg.gov/ftp/GPS/almanacs/yuma/";
	NSString *mailToString = @"http://";
	NSString *emailURLString = [mailToString stringByAppendingString:emailAddress];
	NSURL *emailURL = [NSURL URLWithString:emailURLString];
	[[NSWorkspace sharedWorkspace] openURL:emailURL];
}

	// If the user closes the search window, let's just quit
/*-(BOOL)windowShouldClose:(id)sender
{
	[NSApp terminate:nil];
	return YES;
}*/
//warn before quitting if a command is running
/*-(NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender
{
	int answer;

	if ([liveButton state]){
		answer = NSRunCriticalAlertPanel(@"Warning!", @"Quitting now ?",
																	 @"Cancel", @"Quit", nil);
		if (answer == NSAlertDefaultReturn){
			return NO;
		}
	}
	return YES;
}*/
//since this is a single window app, quit when window closes
-(BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication
{
	return YES;
}

//but don't close window if command is running
-(BOOL)windowShouldClose:(id)sender
{
	if ([liveButton state]){
		NSBeep();
		return NO;
	}
	return YES;
}

-(void)awakeFromNib
{
  [self setLocalDateInfo];
	almanacFlag = 0;
	app_is_runningFlag = 0;
	[calcButton setTitle:@"Lance le calcul"];
}

- (IBAction)selectFiles:(id)sender {
	int result;
	NSArray *fileTypes = [NSArray arrayWithObject:@"txt"];
	NSOpenPanel *oPanel=[NSOpenPanel openPanel];

	[oPanel setAllowsMultipleSelection:NO];
	//result=[oPanel runModalForDirectory:NSHomeDirectory() file:nil types:fileTypes];
	result=[oPanel runModalForDirectory:[[NSFileManager defaultManager] currentDirectoryPath] file:nil types:fileTypes];
		if (result== NSOKButton){
		NSArray *filesToOpen = [oPanel filenames];
		[almanacFile release];
		almanacFile = [filesToOpen objectAtIndex:0];
		[almanacFile retain];
		NSLog(@"File path:%@",almanacFile);
		almanacFlag = 1;
		//[findTextField setStringValue:aFile];
	}
}

- (void)openPanelDidEnd:(NSOpenPanel*)panel returnCode:(int)returnCode contextInfo:(void*)contextInfo {
	//	NSUserDefaults* defaults=[NSUserDefaults standardUserDefaults];
	if (returnCode == NSOKButton) {
		//NSArray* filesToOpen = [panel filenames];
		//		if ([filesToOpen count] > 0) {
	//			[defaults setObject:[[filesToOpen objectAtIndex:0] stringByDeletingLastPathComponent] forKey:@"DefaultImageDirectory"];
 //			[defaults setObject:[[filesToOpen objectAtIndex:0] lastPathComponent] forKey:@"DefaultImageFile"];
 //			[defaults synchronize];
 //		}
 //    [self processAndAddFiles:filesToOpen];
	}
}

-(void)setLocalDateInfo
{
	//NSDate *today = [NSDate date];
	NSTimeZone *local_zone = [NSTimeZone systemTimeZone];
	NSCalendarDate *local_date= [NSCalendarDate calendarDate];
	
	//[timeText setStringValue:[today descriptionWithCalendarFormat:@"%H:%M:%S" timeZone:nil locale:nil]];
	[timeText setStringValue:[local_date descriptionWithCalendarFormat:@"%H:%M:%S"]];
	if ([local_zone isDaylightSavingTime]){
		//NSLog(@"Daylight Saving: Yes");
		[dlsButton setState:NSOnState];
	}
	else {
		//NSLog(@"Daylight Saving: No");
		[dlsButton setState:NSOffState];
	}
	//NSLog(@"Seconds : %d",[local_zone secondsFromGMT]);
	[timezoneText setStringValue:[NSString stringWithFormat:@"%d",[local_zone secondsFromGMT]/3600]];
	//NSLog(@"Day of week: %d",[local_date dayOfWeek]);
	[dayOfWeekPopUp selectItemAtIndex:[local_date dayOfWeek]];
}	
@end

