//
//  GPSDrawing.m
//  GPS_predict
//
//  Created by Alexandre Vial on Sat May 04 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "GPSDrawing.h"
#define PI 3.1415926535898

@implementation GPSDrawing

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)drawRect:(NSRect)rect {
    // Drawing code here.
	NSRect r;
	NSBezierPath *bp;
	int rayon_local;

	NSString *textString;
	NSSize textSize;
	textString = @"GPS - Alexandre 2004";
	textSize = [ textString sizeWithAttributes:nil ];
	
	[[NSColor whiteColor] set]; 
	NSRectFill(rect);

	[[NSColor redColor] set];

	r = NSMakeRect(0, 0, diametre, diametre); // external circle
	bp = [NSBezierPath bezierPathWithOvalInRect:r];
	[bp stroke];

	rayon_local = (int)(diametre/2*cos(PI/6));
	r = NSMakeRect(centre-rayon_local, centre-rayon_local, rayon_local*2, rayon_local*2);
	bp = [NSBezierPath bezierPathWithOvalInRect:r];
	[bp stroke];

	rayon_local = (int)(diametre/2*cos(PI/3));
	r = NSMakeRect(centre-rayon_local, centre-rayon_local, rayon_local*2, rayon_local*2);
	bp = [NSBezierPath bezierPathWithOvalInRect:r];
	[bp stroke];

	[[NSColor yellowColor] set];
	[textString drawAtPoint:NSMakePoint(50,50) withAttributes:nil];
}

- (void)testdraw:(int)nb_sat visiblesat:(sat_to_draw_t *)my_sat
{
	NSString		*string;
	NSMutableDictionary	*fontAttrs;
	NSRect r;
	NSBezierPath *bp;
	int i;
	double x_sat,y_sat;

	fontAttrs = [[NSMutableDictionary alloc] initWithObjectsAndKeys:
				[NSFont boldSystemFontOfSize:16.0], NSFontAttributeName,
				[NSColor redColor], NSForegroundColorAttributeName,
				nil];
	//[fontAttrs setObject:[NSColor blackColor] forKey:NSForegroundColorAttributeName];

	// Lock focus on ourselves.  We need to do this because we're drawing
	// outside of the context of NSView's drawRect: method.
	[self lockFocus];
	//[self drawRect:[self frame]];// clean previous drawing if any
	[[NSColor blueColor] set];
	//NSRectFill(NSMakeRect(0.0, 0.0, diametre, diametre));
	for(i=0;i<nb_sat;i++){
		string = [NSString stringWithFormat:@"%d",my_sat[i].num];
		x_sat = centre + diametre/2.*cos(my_sat[i].elevation)*sin(my_sat[i].azimuth);
		y_sat = centre + diametre/2.*cos(my_sat[i].elevation)*cos(my_sat[i].azimuth);
		r = NSMakeRect(x_sat-5,y_sat-5, 10, 10); // external circle
		bp = [NSBezierPath bezierPathWithOvalInRect:r];
		[bp fill];
		[string drawAtPoint:NSMakePoint(x_sat,y_sat) withAttributes:fontAttrs];
	}
	[self unlockFocus];	
	[[self window] flushWindow];
	NSLog(@"There are %d satelites",nb_sat);
	[fontAttrs release];
}
@end
