#include "gps.h"
#include "common.h"

int lecture(char *file_name,data_almanac_t *data_almanac){
  char temp[50];
  int compteur=0;
  FILE *a_lire;

  a_lire = fopen(file_name, "r");
  // http://www.navcen.uscg.gov/ftp/GPS/almanacs/yuma/  
    
  while (fgets(temp, 50, a_lire)) {
    if (strstr(temp, "ID:")) {
      compteur++;
      //	    printf("Compteur : %d\n",compteur);
      sscanf(temp, "ID: %d",&(data_almanac[compteur-1].sv));
      //            printf("ID:                         %d\n",data_almanac[compteur-1].sv);
    }
    if (strstr(temp, "Health")) {
      sscanf(temp, "Health: %d",&(data_almanac[compteur-1].health));
      //	    printf("Health:                     %d\n",data_almanac[compteur-1].health);
    }
    if (strstr(temp, "Eccentricity")) {
      sscanf(temp, "Eccentricity: %le",&(data_almanac[compteur-1].e));
      //	    printf("Eccentricity:               %12.9e\n",data_almanac[compteur-1].e);
    }
    if (strstr(temp, "Time of Applicability(s)")) {
      sscanf(temp, "Time of Applicability(s): %le",&(data_almanac[compteur-1].TOA));
      //	    printf("Time of Applicability(s):   %12.9e\n",data_almanac[compteur-1].TOA);
    }
    if (strstr(temp, "Orbital Inclination(rad)")) {
      sscanf(temp, "Orbital Inclination(rad): %le",&(data_almanac[compteur-1].I_0));
      //	    printf("Orbital Inclination(rad):   %12.9e\n",data_almanac[compteur-1].I_0);
    }
    if (strstr(temp, "Rate of Right Ascen(r/s)")) {
      sscanf(temp, "Rate of Right Ascen(r/s): %le",&(data_almanac[compteur-1].OMEGA_DOT));
      //	    printf("Rate of Right Ascen(r/s):   %12.9e\n",data_almanac[compteur-1].OMEGA_DOT);
    }
    if (strstr(temp, "SQRT(A)")) {
      sscanf(temp, "SQRT(A) (m 1/2): %le",&(data_almanac[compteur-1].SQRT_A));
      //	    printf("SQRT(A) (m^1/2):            %12.9e\n",data_almanac[compteur-1].SQRT_A);
    }
    if (strstr(temp, "Right Ascen at Week(rad)")) {
      sscanf(temp, "Right Ascen at Week(rad): %le",&(data_almanac[compteur-1].OMEGA_0));
      //	    printf("Right Ascen at TOA(rad):    %12.9e\n",data_almanac[compteur-1].OMEGA_0);
    }
    if (strstr(temp, "Argument of Perigee(rad)")) {
      sscanf(temp, "Argument of Perigee(rad): %le",&(data_almanac[compteur-1].OMEGA));
      //	    printf("Argument of Perigee(rad):   %12.9e\n",data_almanac[compteur-1].OMEGA);
    }
    if (strstr(temp, "Mean Anom(rad)")) {
      sscanf(temp, "Mean Anom(rad): %le",&(data_almanac[compteur-1].M_0));
      //	    printf("Mean Anom(rad):             %12.9e\n",data_almanac[compteur-1].M_0);
    }
    if (strstr(temp, "Af0(s)")) {
      sscanf(temp, "Af0(s): %le",&(data_almanac[compteur-1].Af0));
      //	    printf("Af0(s):                     %12.9e\n",data_almanac[compteur-1].Af0);
    }
    if (strstr(temp, "Af1(s/s)")) {
      sscanf(temp, "Af1(s/s): %le",&(data_almanac[compteur-1].Af1));
      //	    printf("Af1(s/s):                   %12.9e\n",data_almanac[compteur-1].Af1);
    }
    if (strstr(temp, "week")) {
      sscanf(temp, "week: %d",&(data_almanac[compteur-1].week));
      //	    printf("week:                       %d\n",data_almanac[compteur-1].week);
    }
  }
  fclose(a_lire);
  return compteur;
}

/*void DisplayTime( double Time_u )
{
    int Week, DayOfWeek, Hour, Minute, Second;
    char	*DayName[7] ={  "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"  };
    Week = Time_u / SecPerWeek;
    Time_u = Time_u - (Week * SecPerWeek);
    
    DayOfWeek = Time_u / SecPerDay;
    Time_u = Time_u - (DayOfWeek * SecPerDay);
    
    Hour = Time_u / SecPerHour;
    Time_u = Time_u - (Hour * SecPerHour);
    
    Minute = Time_u / SecPerMin;
    Time_u = Time_u - (Minute * SecPerMin);
    
    Second = Time_u;
    
   // if (Week != 0) printf( "Week no %3d ", Week );
    printf( "Week no %3d ", Week );
    printf( "%s %2d:%2d:%2d", DayName[DayOfWeek], Hour, Minute, Second );
}*/

void calcul_position(  
		     data_almanac_t *data_almanac,
		     double local_time,
		     int WeekNo,
		     position_sat_t *position_sat){
    double T;           /* Copy of current time */
    double tk;          /* Time ellapsed from reference epoch */
    double Mk;          /* Mean anomaly */
    double Phik;        /* Argument of latitude */
    double xkp, ykp;    /* Position in Keplerian orbit, in the orbital plane */
    double Omegak;      /* Corrected longitude of ascending node */
    double ik;       /* Inclination */
    double SinOmegak, CosOmegak; /* Sin and cos of angular pos in orbit */
    double Sinik, Cosik;   /* Sin and cos of inclintion */
    double A;        /* Radius of orbit, circular orbit approximation */
    double n0;          /* Computed mean motion */
    double Ek,Ek_old;       /* Eccentry anomaly */
    double rk;      /* Corrected orbit radius at current pos */
	//    double Divisor;     /* Temporary */
    double Vk;//,SinVk, CosVk;  /* Sin and cos of true anomaly, i.e. of actual */
    /* corrected pos in orbit */
    
    /* printf( "\nFor sat %2d ", data_almanac->SatId ); */
    
    T = local_time;
    //    printf("Temps initial : %.1f ",T);
    /* Correction for old almanac */
    if (WeekNo != data_almanac->week) { // imposible avec mon implementation...
		T = T + (WeekNo - data_almanac->week) * SecPerWeek;}
    
    /* Time from almanac reference epoch */
    tk = T - data_almanac->TOA;
    /* printf( "\nT %le Toa %le Tk %le\n", T, data_almanac->Toa, Tk ); */
    
    if (tk > 302400)
    {
	tk -= 604800;
    }
    if (tk < -302400)
    {
	tk += 604800;
    }
    //     printf( "Tk %.1f ", tk ); 
    
    /* Semi major axis, for approximation of circular orbit */
    A = data_almanac->SQRT_A * data_almanac->SQRT_A;
    /* printf( "Axis %le ", A ); */
    
    /* Computed mean motion */
    n0 = sqrt( MU / (A*A*A) );
    /* printf( "n0 %le \n", n0 ); */
    
    /* Mean anomaly */
    Mk = fmod( data_almanac->M_0 + (n0 * tk), 2.0*PI );
    /*printf( "Mk %le ", Mk ); */
    
    /* Eccentric anomaly in radians */
    Ek = Mk;   /*start value for E*/
    do 
    {
	Ek_old = Ek;
	Ek = Mk + data_almanac->e * sin(Ek);
    } while (fabs(Ek - Ek_old) >= 1.0e-8);

    Vk = atan2(sqrt( 1.0 - (data_almanac->e * data_almanac->e)) * sin(Ek),cos(Ek) - data_almanac->e);
    
    Phik = Vk + data_almanac->OMEGA;
    
    /* Compute corrected radius in meters and inclination in radians */
    rk = A * ( 1.0 - data_almanac->e * cos(Ek) ); 
    ik = data_almanac->I_0;
    /* Default inclination = 0.30 semicircles */ //AV already included !!!
       /* printf( "Radius %le Inclk %le \n", rk, ik*(180.0/PI) );*/
    
    /* Position in orbital plane */
    xkp = rk * cos(Phik);  /* Or use Axis instead of corrected radius */
    ykp = rk * sin(Phik);
    /* printf( "Xkp %le Ykp %le ", Xkp, Ykp ); */
    
    /* Corrected longitude of ascending node */
    Omegak = data_almanac->OMEGA_0 + (data_almanac->OMEGA_DOT - OMEGA_DOT_E)*tk - OMEGA_DOT_E * data_almanac->TOA;
    /* printf( "Omegak %le \n", Omegak*(180.0/PI) ); */
    
    /* Sinus and cosinus of argument of latitude and inclination */
    SinOmegak = sin(Omegak);
    CosOmegak = cos(Omegak);
    Sinik  = sin(ik);
    Cosik  = cos(ik);
    
    /* Earth fixed coordinates */
    position_sat->x = (xkp * CosOmegak) - (ykp * Cosik * SinOmegak);
    position_sat->y = (xkp * SinOmegak) + (ykp * Cosik * CosOmegak);
    position_sat->z = ykp * Sinik;
    //    printf( "Earth fix coord %le %le %le\n", Position->x, Position->y, Position->z );  
}
