/*
Mon programme pour localiser les satelltes GPS

*/

#include "gps.h"
#include "r1.h"
#include "common.h"
#include "gps-alex1.h"

/****************************************************************************/

int main_gps(char *almanac, int Hour, int Minute, int UTC_Zone, int Day, int long_d, int long_m, int lat_d, int lat_m, int alt, sat_to_draw_t *sat_to_draw){
	int i;
	int nb_sat_ok,nb_sat_vis;
	double local_time;
	double user_pos[3];
	data_almanac_t data_almanac[NB_SAT];
	position_sat_t position_sat[NB_SAT];

	nb_sat_ok=lecture(almanac,data_almanac); /* lecture du fichier "almanac.dat" */
	printf("Nb sat ok : %d\n",nb_sat_ok);
	printf("Time: %d:%d Jour:%d\n",Hour, Minute, Day);
	local_time = (double)((Hour-UTC_Zone) * 3600 + Minute * 60 + Day * 24 * 3600);
	
	user_info(long_d, long_m, lat_d, lat_m, alt, user_pos);
	printf("Time: %f\n",local_time);

	//    printf("\nCalcul des positions pour les %d satellites disponibles\n\n",nb_sat_ok);

	for (i=0;i<nb_sat_ok;i++){
		if (data_almanac[i].health==0){
			printf("Satellite %d : ok ",data_almanac[i].sv),
			calcul_position(&(data_almanac[i]),local_time,data_almanac[i].week,&(position_sat[i]));
			calc_azimel(&(position_sat[i]),user_pos); /* code issu de gpscode */
		}
		else printf("Satellite %d pas bon\n",data_almanac[i].sv);
	}
	/* affichage azimuth - elevation */
	nb_sat_vis = 0;
	printf("\nAffichage des azimuths et elevations pour les satellites visibles\n\n");
	for (i=0;i<nb_sat_ok;i++){
		if (data_almanac[i].health==0 && position_sat[i].elevation>0.0){
			//printf("Satellite %2d :  El=%6.2f  Az=%6.2f\n",data_almanac[i].sv,position_sat[i].elevation*180.0/PI,position_sat[i].azimuth*180.0/PI);

			sat_to_draw[nb_sat_vis].num = data_almanac[i].sv;
			sat_to_draw[nb_sat_vis].elevation = position_sat[i].elevation;
			sat_to_draw[nb_sat_vis].azimuth = position_sat[i].azimuth;			
			nb_sat_vis++;
		}
	}
	return(nb_sat_vis);
}


/*
**** Week  96 almanac for SV-01 ************
ID:                         01                             sv
Health:                     000
Eccentricity:               5.142688751E-003               e
Time of Applicability(s):   5.038080000E+005               TOA
Orbital Inclination(rad):   9.651939869E-001               I_0
Rate of Right Ascen(r/s):  -7.920330169E-009               OMEGA_DOT
SQRT(A) (m^1/2):            5.153721680E+003               SQRT_A
Right Ascen at TOA(rad):   -3.074903965E+000               OMEGA_0
Argument of Perigee(rad):  -1.697759151E+000               OMEGA
Mean Anom(rad):            -2.709202766E-001               M_0
Af0(s):                     1.840591431E-004               Af0
Af1(s/s):                   0.000000000E+000               Af1
week:                       096
*/
